//
// alarm-desklett.inc
//


// start-position of Window

dim maxix = 350
dim maxiy = 0



// some helpfull stuff
dim startdir = wxGetWorkingdirectory()
dim os=left(lcase(wxGetOsDescription()),3)

// size of Window

dim sizex = 66
dim sizey = 20
if os = "win" then
  sizex = 76
  sizey = 22
end if

dim slash = "/"

if os = "win" then
  slash = "\\"
end if

// create a filename for configuration
if !wxdirExists(wxGetHomedir() & slash & ".wxb-deskletts") then
  wxMkDir(wxGetHomedir() & slash & ".wxb-deskletts")
end if

dim al_configname = replace(startdir, "/" , "#")
al_configname = replace(al_configname, "\\" , "#")
al_configname = replace(al_configname, ":" , "#")
al_configname = replace(al_configname, " " , "#")
al_configname &= "alarm_desklett.inc"

//  read in the Window-Position
dim al_configsoundfilename = wxGetHomedir() & slash & ".wxb-deskletts" & slash & al_configname & "_snd"

dim al_configfilename = wxGetHomedir() & slash & ".wxb-deskletts" & slash & al_configname & "_pos"
if wxfileexists(al_configfilename) then
   freeNum= freeFile()
     open al_configfilename For Input As #freeNum
        Line Input #freeNum, maxix
        Line Input #freeNum, maxiy
     close #freeNum
end if
'wxmessagebox(configfilename)
dim al_frame
dim framename = "wxb-Desklett"
dim al_timer
dim theelement
dim al_down


// Windows and Linux need different methods
// to display borderless windows
dim border

// our elemts need individual IDs
dim cid = wxID_Highest
dim optionmenue = new wxMenu()
dim optionmenueid1 = cid
optionmenue.append( optionmenueid1, al_text1 , al_text1 )

//---- added by Blue Shadow ----
cid+=1
dim optionmenueid2 = cid
optionmenue.append( optionmenueid2, al_text2 , al_text2 )
cid+=1
dim optionmenueid3 = cid
//---- end of insertion ----

optionmenue.append( optionmenueid3, al_text3 , al_text3 )
optionmenue.Enable(optionmenueid3 ,false)

//----------------------------------
// define your global variables here
//----------------------------------
// USERCODE start

dim al_timer2
dim bitmap1
dim bitmap2
dim myDC
dim dc
dim ky = -4 //correcture for textplacement (y -axis)
dim mycol

// USERCODE end
//----------------------------------


window_create( )
sub window_create( )

 
  ' -- create the Window --
  dim linuxborder = command(3)
  if os = "win" then
   border = 1
  else
   if linuxborder = "-border" then
    border = 0
   else
    border = 2
   end if
  end if
  if border = 1 then
'   al_frame = new wxFrame( Nothing, -1, framename, wxPoint(maxix, maxiy), wxSize(sizex, sizey) , wxSUNKEN_BORDER|wxSTAY_ON_TOP|wxFRAME_NO_TASKBAR)
  al_frame = new wxFrame( Nothing, -1, framename, wxPoint(maxix, maxiy), wxSize(sizex, sizey) , wxSTAY_ON_TOP|wxFRAME_NO_TASKBAR)

  end if
  if border = 0 then
   al_frame = new wxFrame( Nothing, -1, framename, wxPoint(maxix, maxiy), wxSize(sizex, sizey) )
 //wxSIMPLE_BORDER
  end if
  if border = 2 then
    al_frame = new wxFrame( Nothing, -1, framename, wxPoint(maxix, maxiy), wxSize(sizex, sizey) , wxFRAME_TOOL_WINDOW)
  end if
 

  dim al_dummybutton = new wxButton(al_frame, -1, "")
  al_dummybutton.show(0)
'  frame.setbackgroundcolor(dummybutton.getbackgroundcolor())

'  mainsizer = new wxBoxsizer(wxVERTICAL)
'  vsizer = new wxBoxsizer(wxHORIZONTAL)
'  mainsizer.addsizer(vsizer)

  cid += 1
  al_timer = new wxTimer( al_frame , cid ) 
  Connect( al_frame, cid, wxEVT_TIMER, "ShowMouse" )
  Connect( al_frame, optionmenueid1, wxEVT_COMMAND_MENU_SELECTED, "al_optionmenu_clicked" )

//---- added by Blue Shadow ----
  Connect( al_frame, optionmenueid2, wxEVT_COMMAND_MENU_SELECTED, "hide_frame" )
  Connect( al_frame, optionmenueid3, wxEVT_COMMAND_MENU_SELECTED, "show_frame" )
//---- end of insertion ----


//----------------------------------------------------
// USERCODE start
//----------------------------------------------------
// an example-element (clock), replace it with something else
// it uses the sub show_time()



  bitmap1 = new wxemptyBitmap(100,100)
  bitmap1.loadfile(wxgetworkingdirectory() & "/back_dark.bmp",  wxBITMAP_TYPE_ANY )
  bitmap2 = new wxemptyBitmap(100,100)
  bitmap2.loadfile(wxgetworkingdirectory() & "/back_dark.bmp",  wxBITMAP_TYPE_ANY )


  cid +=1 : dim timer2id = cid
  al_timer2 = new wxTimer( al_frame , timer2id )
  al_timer2.Start( 1000 )

  Connect( al_frame, timer2id, wxEVT_TIMER, "show_time" )


  myDC=new wxMemoryDC() 
  myDC.SelectObject(bitmap1) 



//----------------------------------------------------
// USERCODE end
//----------------------------------------------------




  // now handle inbuilt events (movement, popup-menue)
   al_frame.settooltip(al_text0)
   connect(al_frame,wxEVT_LEFT_UP,"UnSetPress")
   connect(al_frame,wxEVT_LEFT_DOWN,"SetPress")
   connect(al_frame,wxEVT_MIDDLE_UP,"UnSetPress")
   connect(al_frame,wxEVT_MIDDLE_DOWN,"SetPress")
   connect(al_frame,wxEVT_RIGHT_DOWN,"optionmenu_show")

'  frame.setSizer(mainsizer)
'  frame.fit()
'  frame.setautolayout(true) 
  al_frame.Show(True)



end sub


'------------ this part is for the movement -------

 // move main - window

 sub ShowMouse ( event ) // Update position in realtime 
  if al_down = 0 then :return :end if
  dim mousePoint = wxGetMousePosition() 
  maxix = mousePoint.GetX() - sizex/2
  maxiy = mousePoint.GetY() - sizey/2
  al_frame.Move( maxix , maxiy )  
 end sub 


 sub SetPress( event )
  al_down=1 : al_timer.Start( 20 ) 
 end sub
 sub UnSetPress( event )
  al_down=0 : al_timer.stop()
 end sub

'------------end of movement-routines ---------------

sub optionmenu_show( event )
   al_frame.PopupMenuXY(optionmenue,10,19)
end sub

sub al_optionmenu_clicked( event )
 dim theid = event.getID()
 if theid = optionmenueid1 then
   al_onQuit(1)
 end if
end sub

sub al_onQuit( event )

   // save current position and exit
   if maxix <0 then:maxix=0:end if
   if maxiy <0 then:maxiy=0:end if
   freeNum= freeFile()
     open al_configfilename For Output As #freeNum
        print #freeNum , maxix
        print #freeNum , maxiy
     close #freeNum
  al_frame.show(0)
end sub

//---- added by Blue Shadow ----
sub hide_frame( event )
  optionmenue.Enable(optionmenueid3 ,true)
  optionmenue.Enable(optionmenueid1 ,false)
  frame.show(0)
  optionmenue.Enable(optionmenueid2 ,false)
end sub

sub show_frame ( event )
  optionmenue.Enable(optionmenueid1 ,true)
  optionmenue.Enable(optionmenueid2 ,true)
  optionmenue.Enable(optionmenueid3 ,false)
  frame.show(1)
end sub
//---- end of insertion ----


//----------------------------------
// USERCODE (subs)
//----------------------------------
// put your own subroutines here

sub show_time( event )

  dim bmphour = lng_Alarm_desklett_noalarm
  dim bmpminute = ""




if Al_Next_Alarm < 25000 then

  bmphour = mid( str(Al_Next_Alarm) , 2 , 2 )
  bmpminute = ":" & right( str(Al_Next_Alarm) , 2 ) 
end if


   dim alarmHour=val(mid(str(Al_Next_Alarm),2,2))
   dim alarmMinute=val(right(str(Al_Next_Alarm),2))    
   
    ' get the current hour, minute and second 
    dim theTime = time() 

    dim theHour = int(val( mid( theTime, 1, 2 ) ))
    dim theMinute = int(val( mid( theTime, 4, 2 ) ))


  dim showHour = ""
  dim showMinute = ""
  if theHour<=alarmHour then

     showHour = theHour - alarmHour

    if theMinute>alarmMinute then
      showHour += 1
      showMinute = 60-theMinute + alarmMinute
    else
      showMinute = alarmMinute - theMinute
    end if

    showHour = "0" & abs(showHour)
    showMinute = "0" & showMinute
    showHour = right(showHour,2)
    showMinute = right(showMinute,2)
  end if


  if bmphour = lng_Alarm_desklett_noalarm then
   showHour = ""
   showMinute = ""
  end if

  'theelement.setlabel(showHour & ":" & showMinute)

       myDC.selectObject(bitmap1)
       dim cDC = wxClientDC( al_frame )


       'cDC.clear()
       cDC.Blit( 0, 0 ,sizex,sizey , myDC, 0, 0)

       'myDC.drawline(10,y,50,y)

       cDC.SetTextForeground( wxColor(0,0,0) )


       if os="win" then
          cDC.setFont(wxFont(9,wxDEFAULT,wxNORMAL,wxBOLD))
       else
          cDC.setFont(wxFont(11,wxDEFAULT,wxNORMAL,wxNORMAL))
          ky = 0
       end if 
       cDC.DrawText(bmphour & bmpminute, 1, 4+ ky)
 
       cDC.SetTextForeground( wxColor(255,000,000) )

       cDC.DrawText(showHour & ":" & showMinute, 36, 4+ ky)

//--find soundfile 

dim soundfile = "bellwin.wav"
if wxfileexists(al_configsoundfilename) then
   freeNum= freeFile()
     open al_configsoundfilename For Input As #freeNum
        Line Input #freeNum, soundfile
     close #freeNum
end if

   if showHour = "00" AND showMinute = "00" then
      if os="win" then
        dim hshell = "hshell.exe "
        wxexecute(hshell & "playwave.exe \\\"" & wxGetworkingdirectory() & "/" & soundfile & "\\\"",0)
      else
        if fileexists("/usr/bin/playwave") then
          wxExecute("playwave " & wxGetworkingdirectory() & "/" & soundfile ,0)
        else
          wxExecute("mplayer " & wxGetworkingdirectory() & "/" & soundfile ,0)
        end if
      end if

    al_timer2.stop()
    wxmessagebox("Alarm! " & Alarmdeskletttext)
    al_timer2.start(1000)
    calculate_next_alarm()
   end if

end sub
















