// alarm.inc
// addon for monthcalendar.wxb
// author:  Mark Ulrich
// license: LGPL
// requires: 
//   alarm_language.inc
//   alarm-desklett.inc


dim rmf_List
dim rmf_List2
dim rmf_months[366]
dim thedeleted[366]




include "alarm_language.inc"

    dim Al_Next_Alarm

   dim al_year = the_year
   dim al_month = right("0" & the_month ,2)
   dim al_day = right("0" & the_day ,2)
dim Alarmdeskletttext

dim rmf_configfilename= configdir & "/monthcal_rmf.cfg"
dim rfmaxix=500
dim rfmaxiy=100

dim rfsizex=400
dim rfsizey=400


dim oldtext
dim oldtime
dim oldischecked
dim deleteindex

'Monthly_notes.setsize(300,144)

'dim mypos1 = new wxSize(30,30)


'Save_Button.setDimensions(338,75+150,150,23)
'Remove_Note.setDimensions(490,75+150,150,23)

dim alarmbox = new wxCheckListBox(frame,-1,wxPoint(338,75+150+23),wxSize(300,134),0,0,wxLB_SORT | wxLB_SINGLE)

dim Alarm_show_Button = new wxButton(frame,-1,lng_Alarm_show_Button,wxPoint(338,390),wxSize(75,23))
connect(Alarm_show_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_show_Button")
Alarm_show_Button.setToolTip(add_alarm_text1)

dim Alarm_add_Button = new wxButton(frame,-1,lng_Alarm_add_Button,wxPoint(338+75,390),wxSize(75,23))
connect(Alarm_add_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_add_Button")

dim Alarm_change_Button = new wxButton(frame,-1,lng_Alarm_change_Button,wxPoint(338+150,390),wxSize(75,23))
connect(Alarm_change_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_change_Button")


dim Alarm_delete_Button = new wxButton(frame,-1,lng_Alarm_delete_Button,wxPoint(338+225,390),wxSize(75,23))
connect(Alarm_delete_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_delete_Button")

dim hsizerB4 = new wxBoxsizer(wxHORIZONTAL)
vsizer2.addsizer( hsizerB4 ,0, wxEXPAND)
hsizerB4.addwindow( alarmbox ,1, wxEXPAND)

dim hsizerB5 = new wxBoxsizer(wxHORIZONTAL)
vsizer2.addsizer( hsizerB5  ,0, wxEXPAND)
hsizerB5.addwindow( Alarm_show_Button ,1, wxEXPAND )
hsizerB5.addwindow( Alarm_add_Button ,1, wxEXPAND )
hsizerB5.addwindow( Alarm_change_Button ,1, wxEXPAND )
hsizerB5.addwindow( Alarm_delete_Button ,1, wxEXPAND )


Al_Choose_Note()

include "alarm-desklett.inc"
Connect( frame, -1, wxEVT_CLOSE_WINDOW, "alinc_onQuit" )
calculate_next_alarm()
Connect( alarmbox, -1, wxEVT_COMMAND_CHECKLISTBOX_TOGGLED, "activate_changed" )




dim reminder_Main_Button = new wxButton(frame,-1,lng_Alarm_tobedone ,wxPoint(660,75+310+50),wxSize(125,23))
connect(reminder_Main_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"check_for_old_alarms")


'vsizer3.addwindow( reminder_Main_Button )



//------------------------------
// show the alarm-desklett
sub S_Alarm_show_Button( event )
 
'wxmessagebox(maxix)

calculate_next_alarm()

    al_frame.Move( 0 , 0 ) 
    al_frame.Move( maxix , maxiy ) 
    al_frame.show(1)
end sub

//------------------------------
// DELETE an alarm
sub S_Alarm_delete_Button( event )
   dim lindex = alarmbox.GetSelection()

   if lindex <0 then 
      wxmessagebox(Al_delete_nothingselected)
     return
   end if
   dim result = wxMessagebox(Al_delete_entry, Al_delete_entry , wxNO|wxYES)

   if result != 2 then
     return
   end if

   dim al_listbox_text = right(alarmbox.getString(lindex) , len(alarmbox.getString(lindex)) -8)
   dim al_listbox_time = left(alarmbox.getString(lindex) , 5)


  //--  now delete alarm from file

   al_year = the_year
   al_month = right("0" & the_month ,2)
   al_day = right("0" & the_day ,2)

   dim al_date
   dim al_time
   dim al_text
   dim al_text2
   dim al_writecheck

   freeNum= freeFile()
     open configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" For Output As #freeNum  

     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm" , "r" )

        while not eof( handle )
          al_writecheck = 1

          al_time = fGets( handle )
          al_text =  fGets( handle )
          al_text2 =  fGets( handle )
               if al_time = al_listbox_time then
                 if al_text = al_listbox_text then
                   al_writecheck = 0
                   alarmbox.delete(lindex)
                 end if
              end if


            if al_writecheck = 1 then

              print #freeNum , al_time
              print #freeNum , al_text
              print #freeNum , al_text2 //- reserved for future
            end if
        wend      
     fclose( handle )
     close #freeNum

'wxmessagebox(alarmbox.getCount())

     if alarmbox.getCount() = 0 then
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       List_notes( 1 )
     else
       wxCopyFile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" , configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       calculate_next_alarm()
     end if

  Make_month(dummy)
  Monthly_Notes.refresh()
end sub

//------------------------------
// ADD a new alarm

dim Alarm_add_frame
dim Alarm_add_textctrl
dim Alarm_add_hourspin
dim Alarm_add_minutespin

sub S_Alarm_add_Button( event )

  if ! Monthly_Notes_iseditable then
     return
  end if

  Alarm_add_frame = new wxFrame( Nothing, -1, add_alarm_text1, wxPoint(-1, -1), wxSize(300 , 100))
  Connect( Alarm_add_frame, -1, wxEVT_CLOSE_WINDOW, "S_Alarm_add_Button_close" )
  Alarm_add_frame.show(1)

  dim Alarm_add_mainsizer = new wxBoxsizer(wxVERTICAL)

  dim Alarm_add_statictext1 = new wxStaticText(Alarm_add_frame , -1 , al_add_alarm_text, wxPoint(-1, -1), wxSize(-1 , -1) )
  Alarm_add_mainsizer.addWindow(Alarm_add_statictext1 , 0 , wxALL|wxEXPAND, 10)

  Alarm_add_textctrl = new wxTextctrl(Alarm_add_frame , -1 , "", wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_add_mainsizer.addWindow(Alarm_add_textctrl , 0 , wxALL|wxEXPAND, 10)


  dim Alarm_add_hsizer1 = new wxBoxsizer(wxHORIZONTAL)
  Alarm_add_mainsizer.addSizer(Alarm_add_hsizer1)

  Alarm_add_hourspin = new wxSpinCtrl(Alarm_add_frame,-1,12,wxPoint(-1,-1),wxSize(-1,-1),wxSP_WRAP + wxSP_ARROW_KEYS )
  Alarm_add_hourspin.SetRange( 0, 23)
  Alarm_add_hsizer1.AddWindow( Alarm_add_hourspin,0,wxALL|wxGROW,8)

  Alarm_add_minutespin = new wxSpinCtrl(Alarm_add_frame,-1,00,wxPoint(-1,-1),wxSize(-1,-1),wxSP_WRAP + wxSP_ARROW_KEYS )
  Alarm_add_minutespin.SetRange( 00, 59)
  Alarm_add_hsizer1.AddWindow( Alarm_add_minutespin,0,wxALL|wxGROW,8)



  dim Alarm_add_button_add = new wxButton(Alarm_add_frame , -1 , al_set, wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_add_mainsizer.addWindow(Alarm_add_button_add , 0 , wxALL|wxEXPAND, 10)
  connect(Alarm_add_button_add,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_add_Button_set")

  dim Alarm_add_button_cancel = new wxButton(Alarm_add_frame , -1 , al_cancel, wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_add_mainsizer.addWindow(Alarm_add_button_cancel , 0 , wxALL|wxEXPAND, 10)
  connect(Alarm_add_button_cancel,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_add_Button_close")


  Alarm_add_statictext1.setbackgroundcolor(Alarm_add_button_add.getbackgroundcolor())
  Alarm_add_frame.setbackgroundcolor(Alarm_add_button_add.getbackgroundcolor())

  Alarm_add_frame.setSizer(Alarm_add_mainsizer)
  Alarm_add_frame.fit()
  'Alarm_add_frame.setautolayout(true)
  Alarm_add_frame.layout()

  Alarm_add_textctrl.setfocus()

end sub

sub S_Alarm_add_Button_set( event )

  dim Alarm_add_text = Alarm_add_textctrl.GetValue()
  if Alarm_add_text = "" then
    wxmessagebox(Al_empty_text_error)
    return
  end if

  dim Al_add_hour = right("0" & Alarm_add_hourspin.GetValue() , 2)
  dim Al_add_minute = right("0" & Alarm_add_minutespin.GetValue() , 2)

  alarmbox.Append(Al_add_hour & ":" & Al_add_minute & " - " & Alarm_add_text & "#wxbasic#")

//--fix:  cannot use last elementcount in SORTED listbox
//-- was fixed

dim i
dim al_listbox_text
dim al_index
for i = 0 to alarmbox.getCount()-1
  al_listbox_text = right(alarmbox.getString(i) , 9)
  if al_listbox_text = "#wxbasic#" then
    'wxmessagebox(i)
    al_index = i
alarmbox.setString(i , left(alarmbox.getString(i) , len(alarmbox.getString(i)) - 9))
  end if
next
  alarmbox.Check(al_index,1)
  Alarm_add_frame.destroy()

  //--  now save alarm to file

   al_year = the_year
   al_month = right("0" & the_month ,2)
   al_day = right("0" & the_day ,2)

   dim Al_FileName = al_year & "_" & al_month & "_" & al_day
   dim al_mycheck = 0
   if wxFileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Al_FileName & ".alm") then
     al_mycheck = 1
   end if

   if !wxDirExists(configdir & "/" & GLOBAL_THEYEAR & "notes") then
     wxMkDir(configdir & "/" & GLOBAL_THEYEAR & "notes")
   end if
   freeNum= freeFile()
     open  configdir & "/" & GLOBAL_THEYEAR & "notes/" & Al_FileName & ".alm" For Append As #freeNum
        print #freeNum , Al_add_hour & ":"  & Al_add_minute
        print #freeNum , Alarm_add_text
        print #freeNum , "1" //- checked
     close #freeNum

   if al_mycheck = 0 then
     List_notes( 1 )
   end if

dim compare = Al_add_hour & ":"  & Al_add_minute & " - " & Alarm_add_text

for i = 0 to alarmbox.getCount()-1
  alarmbox.deselect(i)
  if alarmbox.getString(i) = compare then
    alarmbox.setselection(i)
  end if
next

 
  'Select_Notes_List()
  Make_month(dummy)
  Al_Select_Notes_List(Al_FileName)

  calculate_next_alarm() 

end sub

// --- close the Add_Alarm-Window
sub S_Alarm_add_Button_close( event )

  Alarm_add_frame.destroy()
   
end sub


//------------------------------
// CHANGE a new alarm

dim Alarm_change_frame
dim Alarm_change_textctrl
dim Alarm_change_hourspin
dim Alarm_change_minutespin

sub S_Alarm_change_Button( event )



  if ! Monthly_Notes_iseditable then
     return
  end if

   dim lindex = alarmbox.GetSelection()

   if lindex <0 then 
      wxmessagebox(Al_delete_nothingselected)
     return
   end if

   deleteindex = lindex

   oldtext = right(alarmbox.getString(lindex) , len(alarmbox.getString(lindex)) -8)
   oldtime = left(alarmbox.getString(lindex) , 5)
   oldischecked = alarmbox.ischecked(lindex)
   dim oldhour = left(oldtime,2)
   dim oldminute = right(oldtime,2)

  Alarm_change_frame = new wxFrame( Nothing, -1, change_alarm_text1, wxPoint(-1, -1), wxSize(300 , 100))
  Connect( Alarm_change_frame, -1, wxEVT_CLOSE_WINDOW, "S_Alarm_change_Button_close" )
  Alarm_change_frame.show(1)

  dim Alarm_change_mainsizer = new wxBoxsizer(wxVERTICAL)

  dim Alarm_change_statictext1 = new wxStaticText(Alarm_change_frame , -1 , al_add_alarm_text, wxPoint(-1, -1), wxSize(-1 , -1) )
  Alarm_change_mainsizer.addWindow(Alarm_change_statictext1 , 0 , wxALL|wxEXPAND, 10)

  Alarm_change_textctrl = new wxTextctrl(Alarm_change_frame , -1 , oldtext, wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_change_mainsizer.addWindow(Alarm_change_textctrl , 0 , wxALL|wxEXPAND, 10)


  dim Alarm_change_hsizer1 = new wxBoxsizer(wxHORIZONTAL)
  Alarm_change_mainsizer.addSizer(Alarm_change_hsizer1)

  Alarm_change_hourspin = new wxSpinCtrl(Alarm_change_frame,-1,oldhour,wxPoint(-1,-1),wxSize(-1,-1),wxSP_WRAP + wxSP_ARROW_KEYS )
  Alarm_change_hourspin.SetRange( 0, 23)
  Alarm_change_hsizer1.addWindow( Alarm_change_hourspin,0,wxALL|wxGROW,8)

  Alarm_change_minutespin = new wxSpinCtrl(Alarm_change_frame,-1,oldminute,wxPoint(-1,-1),wxSize(-1,-1),wxSP_WRAP + wxSP_ARROW_KEYS )
  Alarm_change_minutespin.SetRange( 00, 59)
  Alarm_change_hsizer1.addWindow( Alarm_change_minutespin,0,wxALL|wxGROW,8)



  dim Alarm_change_button_change = new wxButton(Alarm_change_frame , -1 , al_set, wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_change_mainsizer.addWindow(Alarm_change_button_change , 0 , wxALL|wxEXPAND, 10)
  connect(Alarm_change_button_change,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_change_Button_set")

  dim Alarm_change_button_cancel = new wxButton(Alarm_change_frame , -1 , al_cancel, wxPoint(-1, -1), wxSize(300 , -1) )
  Alarm_change_mainsizer.addWindow(Alarm_change_button_cancel , 0 , wxALL|wxEXPAND, 10)
  connect(Alarm_change_button_cancel,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_Alarm_change_Button_close")


  Alarm_change_statictext1.setbackgroundcolor(Alarm_change_button_change.getbackgroundcolor())
  Alarm_change_frame.setbackgroundcolor(Alarm_change_button_change.getbackgroundcolor())

  Alarm_change_frame.setSizer(Alarm_change_mainsizer)
  Alarm_change_frame.fit()
  'Alarm_change_frame.setautolayout(true)
  Alarm_change_frame.layout()

  Alarm_change_textctrl.setfocus()

end sub

sub S_Alarm_change_Button_set( event )



//delete old entry

   dim al_listbox_text = oldtext
   dim al_listbox_time = oldtime

  //--  now delete alarm from file

   al_year = the_year
   al_month = right("0" & the_month ,2)
   al_day = right("0" & the_day ,2)

   dim al_date
   dim al_time
   dim al_text
   dim al_text2
   dim al_writecheck

   freeNum= freeFile()
     open configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" For Output As #freeNum  

     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm" , "r" )

        while not eof( handle )
          al_writecheck = 1

          al_time = fGets( handle )
          al_text =  fGets( handle )
          al_text2 =  fGets( handle )
               if al_time = al_listbox_time then
                 if al_text = al_listbox_text then
                   al_writecheck = 0
                   alarmbox.delete(deleteindex)
                 end if
              end if


            if al_writecheck = 1 then

              print #freeNum , al_time
              print #freeNum , al_text
              print #freeNum , al_text2 //- reserved for future
            end if
        wend      
     fclose( handle )
     close #freeNum

'wxmessagebox(alarmbox.getCount())



     if alarmbox.getCount() = 0 then
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       List_notes( 1 )
     else

       wxCopyFile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" , configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")

       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       calculate_next_alarm()
     end if




// add new

  dim Alarm_change_text = Alarm_change_textctrl.GetValue()
  if Alarm_change_text = "" then
    wxmessagebox(Al_empty_text_error)
    return
  end if

  dim Al_change_hour = right("0" & Alarm_change_hourspin.GetValue() , 2)
  dim Al_change_minute = right("0" & Alarm_change_minutespin.GetValue() , 2)

  alarmbox.Append(Al_change_hour & ":" & Al_change_minute & " - " & Alarm_change_text & "#wxbasic#")

//--fix:  cannot use last elementcount in SORTED listbox
//-- was fixed

dim i

dim al_index
for i = 0 to alarmbox.getCount()-1
  al_listbox_text = right(alarmbox.getString(i) , 9)
  if al_listbox_text = "#wxbasic#" then
    'wxmessagebox(i)
    al_index = i
alarmbox.setString(i , left(alarmbox.getString(i) , len(alarmbox.getString(i)) - 9))
  end if
next


  alarmbox.Check(al_index,oldischecked)
  Alarm_change_frame.destroy()

  //--  now save alarm to file

   al_year = the_year
   al_month = right("0" & the_month ,2)
   al_day = right("0" & the_day ,2)

   dim Al_FileName = al_year & "_" & al_month & "_" & al_day
   dim al_mycheck = 0
   if wxFileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Al_FileName & ".alm") then
     al_mycheck = 1
   end if

   if !wxDirExists(configdir & "/" & GLOBAL_THEYEAR & "notes") then
     wxMkDir(configdir & "/" & GLOBAL_THEYEAR & "notes")
   end if
   freeNum= freeFile()
     open  configdir & "/" & GLOBAL_THEYEAR & "notes/" & Al_FileName & ".alm" For Append As #freeNum
        print #freeNum , Al_change_hour & ":"  & Al_change_minute
        print #freeNum , Alarm_change_text
        print #freeNum , oldischecked
     close #freeNum

'   if al_mycheck = 0 then
'     List_notes( 1 )
'   end if

dim compare = Al_change_hour & ":"  & Al_change_minute & " - " & Alarm_change_text

for i = 0 to alarmbox.getCount()-1
  alarmbox.deselect(i)
  if alarmbox.getString(i) = compare then
    alarmbox.setselection(i)
  end if
next

  'Select_Notes_List()
  Make_month(dummy)
  Al_Select_Notes_List(Al_FileName)

  calculate_next_alarm() 

end sub

sub S_Alarm_change_Button_close( event )

  Alarm_change_frame.destroy()
   
end sub

//--------------------------------------------------
// save current position of alarm-desklett and exit
sub alinc_onQuit( event )

OnExit(1)


'   freeNum= freeFile()
'     open al_configfilename For Output As #freeNum
'        print #freeNum , maxix
'        print #freeNum , maxiy
'     close #freeNum
'  end
end sub

//--------------------------------------------------
// load the alarmlist of current day
sub  Al_make_note(File_Data)
   '''wxmessagebox("test")

   dim al_time
   dim Alarm_add_text
   dim al_checked

dim i
dim al_listbox_text
dim al_index


// save the current alarmlistbox
// this is only needed for the checkboxes


if alarmbox.getCount() > 0 then
'wxmessagebox(LastFileData)

  freeNum= freeFile()
    open configdir & "/" & GLOBAL_THEYEAR & "notes/" & LastFileData & ".alm" For Output As #freeNum

          for i = 0 to alarmbox.getCount()-1
             al_time = left(alarmbox.getString(i) , 5)
             Alarm_add_text = right(alarmbox.getString(i) , len(alarmbox.getString(i)) -8)
             al_checked = alarmbox.ischecked(i)

             print #freeNum , al_time
             print #freeNum , Alarm_add_text
             print #freeNum , al_checked

          next
    close #freeNum
end if

   alarmbox.clear()

   if fileexists (configdir & "/" & GLOBAL_THEYEAR & "notes/" & File_Data & ".alm") then

     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & File_Data &  ".alm" , "r" )

        while not eof( handle )

          al_time = fGets( handle )
          Alarm_add_text = fGets( handle )
          al_checked = val(fGets( handle ))
          alarmbox.Append(al_time & " - " & Alarm_add_text & "#wxbasic#")
 
          //-- find out where the entry was set
          //-- (it  is a SORTED listbox)
         
          for i = 0 to alarmbox.getCount()-1
             al_listbox_text = right(alarmbox.getString(i) , 9)
             if al_listbox_text = "#wxbasic#" then
               'wxmessagebox(i)
               al_index = i
               alarmbox.setString(i , left(alarmbox.getString(i) , len(alarmbox.getString(i)) - 9))
             end if
          next
        
          alarmbox.Check(al_index,al_checked)

        wend      
     fclose( handle )

   'wxmessagebox(File_Data)

   Al_Select_Notes_List(File_Data)

   end if
end sub

sub Al_List_notes()



  dim Pathname = configdir
  dim Find_file = new wxDir()
  dim noteentry = ""
  Find_file.Open(Pathname & "/" & GLOBAL_THEYEAR & "notes")
  dim First_file = Left(Find_file.GetFirst("*.alm"),10)

'if First_file > tr_range_from then
'print First_file
'end if

  noteentry = replace(First_file, "_" , " ")

  if First_file != "" then
    if First_file >= tr_range_from then
    if First_file <= tr_range_to then
      if !wxFileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & First_file & ".mcn") then

        noteentry &= " "
        Notes_List.Append(noteentry)
      end if
    end if
    end if

  dim Next_file

  While Next_file <> ""
    noteentry = ""
    Next_file = Left(Find_file.GetNext(),10)

    noteentry = replace(Next_file, "_" , " ")
    if noteentry then
     if Next_file >= tr_range_from then
     if Next_file <= tr_range_to then

      if !wxFileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Next_file & ".mcn") then

        noteentry &= " "
        Notes_List.Append(noteentry)
      end if
     end if
     end if
    end if
  end while

  end if

end sub

sub Al_Choose_Note()


 ' wxmessagebox(GLOBAL_current_date)
  alarmbox.clear()
  dim mydate = replace(GLOBAL_current_date, ".mcn" , "")
  Al_make_note(mydate)


end sub

sub Al_change_month()

  alarmbox.clear()
  dim mydate = replace(GLOBAL_current_date, ".mcn" , "")
  Al_make_note(mydate)

end sub

sub Al_Make_today()

  alarmbox.clear()
  dim mydate = replace(GLOBAL_current_date, ".mcn" , "")
  Al_make_note(mydate)

end sub

sub Al_change_year()

  alarmbox.clear()
  dim mydate = replace(GLOBAL_current_date, ".mcn" , "")
  Al_make_note(mydate)

end sub

sub Al_Make_month(File_Data)

  dim myGLOBAL_current_date = File_Data & ".alm"
  If FileExists (configdir & "/" & GLOBAL_THEYEAR & "notes/" & myGLOBAL_current_date) then

         button[i].SetLabel("[" & button_label[i] & "]")

  end if
end sub


sub Al_List_Notes_first()

    if Fileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Note_List_text & ".alm") then

      Note_List_text &= " "
    end if

end sub

sub Al_List_Notes_next()

    if Fileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Note_List_text & ".alm") then

      Note_List_text &= " "
    end if

end sub

sub calculate_next_alarm()

    // current time
    dim Al_theTime = time() 
    dim Al_theHour = "0" & val( mid( Al_theTime, 1, 2 ) ) 
    Al_theHour=right(Al_theHour,2)
    dim Al_theMinute = "0" & val( mid( Al_theTime, 4, 2 ) )
    Al_theMinute = right(Al_theMinute,2) 
    dim Al_time_now = val(Al_theHour & Al_theMinute)



    // current date
    dim al_time
    dim Alarm_add_text
    dim al_checked


    dim Al_the_date = now()
    dim Al_the_day = right("0" & day(the_date) , 2)
    dim Al_the_month = right("0" &  month(the_date) , 2)
    dim Al_the_year = year(the_date)
    dim Al_the_month_name = monthname(the_date)

    dim Alarmdate = Al_the_year & "_" & Al_the_month & "_" & Al_the_day
'print Alarmdate

   Al_Next_Alarm = 25000

   if fileexists (configdir & "/" & GLOBAL_THEYEAR & "notes/" & Alarmdate & ".alm") then

     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & Alarmdate & ".alm" , "r" )

        while not eof( handle )

          al_time = fGets( handle )
          al_time = val(replace(al_time , ":" , ""))

          Alarm_add_text = fGets( handle )
          al_checked = val(fGets( handle ))


          if al_checked = 1 then
            if al_time > Al_time_now then
              if al_time < Al_Next_Alarm then
                Al_Next_Alarm = al_time + 10000
                Alarmdeskletttext = "\n" & al_time & " - " & Alarm_add_text
                'print Al_Next_Alarm
              end if
            end if
          end if
        wend      
     fclose( handle )

   'wxmessagebox(File_Data)

   end if

end sub

sub activate_changed( event )

'print GLOBAL_current_date

   dim al_time
   dim Alarm_add_text
   dim al_checked
   dim al_myfile = replace( GLOBAL_current_date , ".mcn" , ".alm")


  freeNum= freeFile()
    open configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_myfile For Output As #freeNum

          for i = 0 to alarmbox.getCount()-1
             al_time = left(alarmbox.getString(i) , 5)
             Alarm_add_text = right(alarmbox.getString(i) , len(alarmbox.getString(i)) -8)
             al_checked = alarmbox.ischecked(i)

             print #freeNum , al_time
             print #freeNum , Alarm_add_text
             print #freeNum , al_checked

          next
    close #freeNum

 calculate_next_alarm()

end sub

sub Al_Select_Notes_List(File_Data)
//**MarkNEW2
if Notes_List.getSelection() >= 0 then
  Notes_List.deselect(Notes_List.getSelection())
end if
//**MarkNEW4
disconnect (Notes_List,wxEVT_COMMAND_LISTBOX_SELECTED)


    dim mydate = replace(File_Data , "_" , " ")

    for i = 0 to Notes_List.getCount()-1

        if mydate = left(Notes_List.getString(i) , 10) then

          Notes_List.setselection(i)
          break          
        end if
    next

connect (Notes_List,wxEVT_COMMAND_LISTBOX_SELECTED,"Choose_Note")

end sub

//''' ----------------
dim reminderframe
sub sub_rmf_endmodal( event )

dim lindex
dim haschanged = 0

   for i = 0 to rmf_List2.getCount()-1


     if rmf_List2.ischecked(i) = 0 then

      lindex = i

//--
dim exploderesult = explode(rmf_List2.Getstring(lindex) , "-" )
dim thestring = exploderesult[1]
dim datestring = exploderesult[0]
datestring = replace(datestring , " " , "")
thestring = right(thestring,len(thestring)-1)

   dim al_listbox_time = left(thestring , 5)
   dim al_listbox_text = right(thestring, len(thestring)-8)


  //--  now set check to 0 in file

   al_year = the_year
dim al_month= rmf_months[lindex]

dim al_day= right(datestring,2)


  dim al_date
   dim al_time
   dim al_text
   dim al_text2
   dim al_writecheck
 dim thecheck = 0
   freeNum= freeFile()
     open configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" For Output As #freeNum  

     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm" , "r" )

        while not eof( handle )


          al_time = fGets( handle )
          al_text =  fGets( handle )
          al_text2 =  fGets( handle )


              print #freeNum , al_time
              print #freeNum , al_text
               thecheck = 0
               if al_time = al_listbox_time then
                 if al_text = al_listbox_text then
                    thecheck = 1
                 end if
               end if

               if thecheck = 1 then
                    print #freeNum , 0
                    haschanged = 1
               else
                 print #freeNum , al_text2
               end if


        wend      
     fclose( handle )
     close #freeNum

       wxCopyFile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" , configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       'calculate_next_alarm()



     end if

   next

 if haschanged = 1 then



       Make_month(dummy)
       Monthly_Notes.refresh()

       Choose_Note(dummy)

 end if




dim rfmaxix=reminderframe.getPositionX()
dim rfmaxiy=reminderframe.getPositionY()
dim rfsizex=reminderframe.getSizeWidth()
dim rfsizey=reminderframe.getSizeHeight()


   freeNum= freeFile()
     open rmf_configfilename For Output As #freeNum
        print #freeNum , rfmaxix
        print #freeNum , rfmaxiy
        print #freeNum , rfsizex
        print #freeNum , rfsizey
     close #freeNum


   reminderframe.endmodal(0)
   reminderframe.destroy()



end sub

sub check_for_old_alarms(event)

 ' wxmessagebox("test")

if wxfileexists(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm") then

  wxremovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")

end if

//''' reminderlist


if wxfileexists(rmf_configfilename) then
   freeNum= freeFile()
     open rmf_configfilename For Input As #freeNum
        Line Input #freeNum, rfmaxix
        Line Input #freeNum, rfmaxiy
        Line Input #freeNum, rfsizex
        Line Input #freeNum, rfsizey
     close #freeNum
end if

reminderframe = new wxdialog(nothing, -1, lng_Alarm_tobedone & " " & GLOBAL_THEYEAR,wxPoint(rfmaxix,rfmaxiy) , wxSize(rfsizex,rfsizey), wxRESIZE_BORDER|wxCAPTION)
connect(reminderframe,-1, wxEVT_CLOSE_WINDOW, "sub_rmf_endmodal")

dim rmf_vsizer = new wxBoxSizer(wxVERTICAL)
reminderframe.setsizer(rmf_vsizer)


//-- this list is invisible, just used for sorting
rmf_List = new wxListBox(reminderframe,-1,wxPoint(-1,-1),wxSize(-1,-1),0,0,wxLB_SORT|wxLB_MULTIPLE|wxLB_ALWAYS_SB)
'rmf_vsizer.addwindow(rmf_List ,1, wxEXPAND|wxALL , 6)
rmf_List.show(0)

rmf_List2 = new wxcheckListBox(reminderframe,-1,wxPoint(-1,-1),wxSize(-1,-1),0,0,wxLB_MULTIPLE|wxLB_ALWAYS_SB)
rmf_vsizer.addwindow(rmf_List2 ,1, wxEXPAND|wxALL , 6)

dim rmf_hsizer = new wxBoxSizer(wxHORIZONTAL)
rmf_vsizer.addsizer( rmf_hsizer ,0, wxEXPAND|wxALL , 6 )

dim rmf_Button_ok = new wxButton(reminderframe,-1,"ok",wxPoint(-1,-1),wxSize(-1,-1))
connect(rmf_Button_ok,-1,wxEVT_COMMAND_BUTTON_CLICKED,"sub_rmf_endmodal")
rmf_hsizer.addwindow(rmf_Button_ok ,1,wxEXPAND|wxRIGHT,30)

'dim rmf_el = new wxStatictext(reminderframe,-1,"   ",wxPoint(0,0))
'rmf_hsizer.addwindow(rmf_el ,0,wxEXPAND)

dim rmf_Button_del = new wxButton(reminderframe,-1,lng_Alarm_delete_Button,wxPoint(-1,-1),wxSize(-1,-1))
connect(rmf_Button_del,-1,wxEVT_COMMAND_BUTTON_CLICKED,"sub_rmf_deletealarms")
rmf_hsizer.addwindow(rmf_Button_del ,0)


  dim Pathname = configdir
  dim Find_file = new wxDir()
  dim noteentry = ""
  Find_file.Open(Pathname & "/" & GLOBAL_THEYEAR & "notes")
  dim First_file = Find_file.GetFirst("*.alm")
  dim wholedate = replace(left(First_file , 10), "_" , "")
  dim wholedatetext = right(replace(left(First_file , 10), "_" , "."),5)
  'print First_file

// error in val(), so "bugfix":
  dim wholedateleft = val(left(wholedate,4))
  dim wholedateright = val(right(wholedate ,4))
  if First_file != "" then
//---------------------

    dim al_time
    dim Alarm_add_text
    dim al_checked
    dim handle

    // current time
    dim Al_theTime = time() 
    dim Al_theHour = "0" & val( mid( Al_theTime, 1, 2 ) ) 
    Al_theHour=right(Al_theHour,2)
    dim Al_theMinute = "0" & val( mid( Al_theTime, 4, 2 ) )
    Al_theMinute = right(Al_theMinute,2) 
    dim Al_time_now = val(Al_theHour & Al_theMinute)

    dim the_date = now()
    dim the_day = right("0" & day(the_date),2)
    dim the_month = right("0" & month(the_date),2)
    dim the_year = year(the_date)
    dim monthandday = val(the_month & the_day)
    'print "--" & monthandday
    dim al_time_string

     handle = fOpen(Pathname & "/" & GLOBAL_THEYEAR & "notes/" & First_file , "r" )

        while not eof( handle )

          al_time = fGets( handle )
          al_time_string = al_time
          al_time = val(replace(al_time , ":" , ""))

          Alarm_add_text = fGets( handle )
          al_checked = val(fGets( handle ))


          if al_checked = 1 then

          '  if wholedateleft <= the_year then
              if wholedateright = monthandday then
                if al_time < Al_time_now then
'print Alarm_add_text & "---" & al_time
rmf_List.Append(wholedatetext  & " (" & Month_names[int(wholedateright/100)] & ") - " & al_time_string & "   " & Alarm_add_text)
                end if
              end if
              if wholedateright < monthandday then
'print Alarm_add_text & "---" & al_time
rmf_List.Append(wholedatetext  & " (" & Month_names[int(wholedateright/100)] & ") - " & al_time_string & "   " & Alarm_add_text)

              end if


           ' end if
          end if
        wend      
     fclose( handle )

//---------------------

'return
  dim Next_file

  While Next_file <> ""
    noteentry = ""
    Next_file = Find_file.GetNext()
    noteentry = replace(left(Next_file , 10), "_" , " ")

    wholedate = replace(left(Next_file , 10), "_" , "")
    wholedatetext = right(replace(left(Next_file , 10), "_" , "."),5)


// error in val(), so "bugfix":
    wholedateleft = val(left(wholedate,4))
    wholedateright = val(right(wholedate ,4))

    if noteentry then

    handle = fOpen(Pathname & "/" & GLOBAL_THEYEAR & "notes/" & Next_file , "r" )

        while not eof( handle )

          al_time = fGets( handle )
          al_time_string = al_time
          al_time = val(replace(al_time , ":" , ""))

          Alarm_add_text = fGets( handle )
          al_checked = val(fGets( handle ))


          if al_checked = 1 then

              if wholedateright = monthandday then
                if al_time < Al_time_now then
'print Alarm_add_text & "---" & al_time
rmf_List.Append(wholedatetext & " (" & Month_names[int(wholedateright/100)] & ") - " & al_time_string & "   " & Alarm_add_text)

'rmf_List.Append(right("0"& str(wholedateright),)& " " & Month_names[wholedateleft] & " - " & al_time_string & "   " & Alarm_add_text)


                end if
              end if
              if wholedateright < monthandday then
'print Alarm_add_text & "---" & al_time
'print wholedateright
rmf_List.Append(wholedatetext  & " (" & Month_names[int(wholedateright/100)] & ") - " & al_time_string & "   " & Alarm_add_text)

              end if

          end if
        wend      
     fclose( handle )
    end if
  end while

//'''sort it
dim thetext
dim thetext2
dim kindex=0
dim kmonthname
dim kday
dim kmonth
for i=0 to rmf_List.getCount()-1

  thetext = rmf_List.getString(i)
  kindex = instr(thetext , ")")
  thetext2 = left(thetext,kindex)
  thetext2 = replace(thetext2, ")" , "")
  kmonthname = right(thetext2,len(thetext2)-7)
  kday = mid(thetext2, 4,2)
  kmonth = left(thetext2, 2)
  thetext2 = kmonthname & " " & kday & " " & right(thetext, len(thetext)-kindex)
  rmf_months[i] = kmonth
  rmf_List2.append(thetext2) 
rmf_List2.Check(i)  

next

  end if

reminderframe.showmodal()
'reminderframe.show(1)

end sub


sub sub_rmf_deletealarms( event )

   'if rmf_List.Getselection() <0 then 
   '   wxmessagebox(Al_delete_nothingselected)
   '  return
   'end if
   dim result = wxMessagebox(Al_delete_entries, Al_delete_entries , wxNO|wxYES)

   if result != 2 then
     return
   end if


dim thestring
dim datestring
dim exploderesult = {}



dim thekilled = 0

  for lindex=0 to rmf_List2.GetCount()-1


    if rmf_List2.Selected(lindex) then
'print "..." & lindex


//--
exploderesult = explode(rmf_List2.Getstring(lindex) , "-" )
thestring = exploderesult[1]
datestring = exploderesult[0]
datestring = replace(datestring , " " , "")
thestring = right(thestring,len(thestring)-1)

   dim al_listbox_time = left(thestring , 5)
   dim al_listbox_text = right(thestring, len(thestring)-8)


  //--  now delete alarm from file

   al_year = the_year
dim al_month= rmf_months[lindex]

dim al_day= right(datestring,2)


   dim al_date
   dim al_time
   dim al_text
   dim al_text2
   dim al_writecheck
 '    print configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm"

   freeNum= freeFile()
     open configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" For Output As #freeNum  
dim numberofentries = 0
'print GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm"
     dim handle = fOpen(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm" , "r" )

        while not eof( handle )
          al_writecheck = 1

          al_time = fGets( handle )
          al_text =  fGets( handle )
          al_text2 =  fGets( handle )
numberofentries += 1
               if al_time = al_listbox_time then
                 if al_text = al_listbox_text then
                   al_writecheck = 0
                   'rmf_List.delete(lindex)
                    thedeleted[thekilled] = lindex
                    thekilled += 1
numberofentries -= 1
                 end if
              end if


            if al_writecheck = 1 then

              print #freeNum , al_time
              print #freeNum , al_text
              print #freeNum , al_text2 //- reserved for future
            end if
        wend      
     fclose( handle )
     close #freeNum

'wxmessagebox(alarmbox.getCount())

      if numberofentries = 0 then
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       List_notes( 1 )
      
     else
       wxCopyFile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm" , configdir & "/" & GLOBAL_THEYEAR & "notes/" & al_year & "_" & al_month & "_" & al_day & ".alm")
       wxRemovefile(configdir & "/" & GLOBAL_THEYEAR & "notes/tmp.alm")
       calculate_next_alarm()
     end if


//---
    end if
  end for

'print "--" & thekilled
for i = thekilled-1 to 0 step -1
'print thedeleted[i]
  rmf_List2.deselect(thedeleted[i])
  rmf_List2.delete(thedeleted[i])
next

  Make_month(dummy)
  Monthly_Notes.refresh()
end sub

function explode (wholestr,splitter)
 dim word={}
 dim spos=0
 dim i=1
 dim n=instr(0,wholestr,splitter)
 word[0]=left(wholestr,n-1)
 n=instr(spos,wholestr,splitter)
 spos=n+1
 while instr(spos,wholestr,splitter)
  n=instr(spos,wholestr,splitter)
  word[i]=mid(wholestr,spos,n-spos)
  spos=n+1
  i+=1
 end while
 word[i]=mid(wholestr,n+1,length(wholestr))
 return word
end function


























