// menue.inc
// addon for monthcalendar.wxb
// author:  Mark Ulrich
// license: LGPL
// requires: 
//   
//  this is NOT a Plugin !   

dim id_sunday=0
dim id_monday=0

dim menu_startdir = wxGetWorkingdirectory()
dim menu_os=left(lcase(wxGetOsDescription()),3)


dim menu_slash = "/"

if menu_os = "win" then
  menu_slash = "\\"
end if

// create a filename for configuration
if !wxdirExists(wxGetHomedir() & menu_slash & ".monthcalendar") then
  wxMkDir(wxGetHomedir() & menu_slash & ".monthcalendar")
end if

dim menu_lang_configname = replace(menu_startdir, "/" , "#")
menu_lang_configname = replace(menu_lang_configname, "\\" , "#")
menu_lang_configname = replace(menu_lang_configname, ":" , "#")
menu_lang_configname = replace(menu_lang_configname, " " , "#")
dim menu_week_configname = menu_lang_configname & "menue_week.inc" // weeksort-patch
menu_lang_configname &= "menue_lang.inc"

//  read in the stored language
dim menu_lang_configfilename = wxGetHomedir() & menu_slash & ".monthcalendar" & menu_slash & menu_lang_configname
if wxfileexists(menu_lang_configfilename) then
   dim menu_freeNum= freeFile()
     open menu_lang_configfilename For Input As #menu_freeNum
        Line Input #menu_freeNum, GLOBAL_language

     close #menu_freeNum
end if


dim menu_week_configfilename = wxGetHomedir() & menu_slash & ".monthcalendar" & menu_slash & menu_week_configname // weeksort-patch
if wxfileexists(menu_week_configfilename) then
   dim menu_freeNum2= freeFile()
     open menu_week_configfilename For Input As #menu_freeNum2
        Line Input #menu_freeNum2, startonmonday

     close #menu_freeNum2
end if


'wxmessagebox(GLOBAL_language)


include "menu_language.inc"




sub Menu_init()

end sub



sub Menu_makemenue()

   Menu_makemenue_file()
   Menu_makemenue_language()
   Menu_makemenue_weeksort()
   Menu_makemenue_options()

end sub

sub Menu_makemenue_file()

  // do we need a file-menue? Not yet

end sub

' add menubar to the frame
dim m_id = wxID_HIGHEST + 1000
dim mBar = new wxMenuBar()

sub Menu_makemenue_language()
//''' ** menue **

    
    
    frame.SetMenuBar(mBar)
    ' build the "File" dropdown menu
    dim mLanguage = new wxMenu()

    mBar.Append(mLanguage, menu_language)
dim lang
dim i = 1
for each lang in languages 

    m_id += 1

      
    mLanguage.Append( m_id, menu_shortcut[i], menu_text[i] )
    'mLanguage.Append( ID_DE, menu_german_shortcut, menu_german )

    Connect( frame, m_id, wxEVT_COMMAND_MENU_SELECTED, "change_language" )
i += 1
next
end sub

sub Menu_makemenue_weeksort()  // weeksort-patch


    dim mWeeksort = new wxMenu()

    mBar.Append(mWeeksort, menu_weeksort)
dim lang


    m_id += 1
    id_sunday=m_id
    mWeeksort.Append( m_id, menu_startonsunday )
    
    m_id += 1
    id_monday=m_id
    mWeeksort.Append( m_id, menu_startonmonday )
    

    Connect( frame, m_id, wxEVT_COMMAND_MENU_SELECTED, "change_weeksort" )
    Connect( frame, m_id-1, wxEVT_COMMAND_MENU_SELECTED, "change_weeksort" )


end sub

dim  menu_optionsidentifier=[]
sub Menu_makemenue_options()

    dim mOptions = new wxMenu()

    mBar.Append(mOptions, menu_options)
    i=1
    dim menuepoint
    for each menuepoint in menu_options_shortcut

       m_id += 1    
       menu_optionsidentifier.append(m_id)
       mOptions.Append( m_id, menuepoint , menu_text[i])
       Connect( frame, m_id, wxEVT_COMMAND_MENU_SELECTED, "change_option" )

       i+=1

     next

end sub


sub change_language( event )

  dim menu_lang_id = event.getID() - wxID_HIGHEST -1000
  'wxmessagebox(menu_lang_id)

  GLOBAL_language = languages[menu_lang_id]



   dim menu_freeNum = freeFile()
     open menu_lang_configfilename For Output As #menu_freeNum
        print #menu_freeNum , GLOBAL_language

     close #menu_freeNum


   restart()
end sub

sub change_weeksort( event )  // weeksort-patch

dim curID = event.getID()
  if curID = id_monday then
  startonmonday=1
  else
  startonmonday=0
  end if
  
  // wxmessagebox(id_monday&"--"&curID)

  

   dim menu_freeNum = freeFile()
     open menu_week_configfilename For Output As #menu_freeNum
        print #menu_freeNum , startonmonday

     close #menu_freeNum


   restart()
end sub

sub change_option( event )

   dim curID = event.getID()
   dim check_id

   dim i=0
   for each check_id in menu_optionsidentifier

     if check_id = curID then

      // here you can branch to the subroutines
      if i = 0 then
          'print "sound"
          setsound()
      end if
      if i = 1 then
          'print "sound"
          wxbcard()
      end if
      
      if i = 2 then
          wxmessagebox("entered Options-test")
          //setsound()
      end if

     end if
     i+=1
   next
end sub









