//''' -- the search-window

 dim gk_search = 1

 include "search_language.inc"

dim search_Main_Button = new wxButton(frame,-1,lng_search ,wxPoint(660,75+310+50),wxSize(125,23))

connect(search_Main_Button,-1,wxEVT_COMMAND_BUTTON_CLICKED,"S_search_Main_Button")

vsizer3.addwindow( search_Main_Button )

 dim sframe1 = new wxframe( Nothing, -1, lng_search, wxPoint(200,200), wxSize(500,400))

 dim svsizer1 = new wxBoxSizer( wxVERTICAL )

 dim searchsizer = new wxBoxSizer( wxHORIZONTAL) 
 dim searchsizer2 = new wxBoxSizer( wxVERTICAL)
 svsizer1.AddSizer(searchsizer,0,wxEXPAND)
 searchsizer.AddSizer(searchsizer2,1,wxEXPAND)

 dim searchtext = new wxTextCtrl(sframe1, -1 , "")
 searchsizer.AddWindow( searchtext,20,wxEXPAND|wxALL,6)

 dim searchbutton=new wxButton(sframe1, -1, lng_search)
 connect(searchbutton,wxEVT_COMMAND_BUTTON_CLICKED,"search_button")

    dim el = new wxStaticText(sframe1,-1, " ",wxPoint( -1, -1 ))
    searchsizer.addwindow(el,1)
    el.setbackgroundcolor(searchbutton.getbackgroundcolor())

 dim gk = new wxCheckbox(sframe1,-1,lng_search_ignorecase)
 gk.setvalue(1)
 searchsizer.AddWindow(gk,0,wxALL,6)
 connect(gk,wxEVT_COMMAND_CHECKBOX_CLICKED ,"gk_toggle")

    el = new wxStaticText(sframe1,-1, " ",wxPoint( -1, -1 ))
    searchsizer.addwindow(el,1)
    el.setbackgroundcolor(searchbutton.getbackgroundcolor())


 searchsizer.AddWindow(searchbutton,0,wxEXPAND|wxALL,6)

 sframe1.setbackgroundcolor(searchbutton.getbackgroundcolor())


 dim slistbox1= new wxListBox(sframe1,1,wxPoint(-1,-1),wxSize(-1,-1),0,0,wxLB_SINGLE)
 svsizer1.AddWindow( slistbox1,1,wxEXPAND)
 sframe1.SetSizer( svsizer1 )
 sframe1.Show( 0 )
 dim sresults = {}
 Connect( sframe1, wxEVT_CLOSE_WINDOW, "search_hide" )
 connect(slistbox1,wxEVT_COMMAND_LISTBOX_SELECTED,"searchlist_clicked")

sub S_search_Main_Button( event )

 sframe1.Show( 1 )

end sub

sub search_hide( event )
 sframe1.Show( 0 )
end sub

sub gk_toggle( event )
 
  if gk.getValue() then
   gk_search = 1
  else
   gk_search = 0   
  end if

end sub


sub search_button( event )

  dim folder
  dim folders = {}
  dim foldercounter = 0
  dim Pathname = configdir

  slistbox1.clear()

  //--- first add all /YEARnotes -folders to a table ---

  dim Find_file = new wxDir()
  dim noteentry = ""
  Find_file.Open( Pathname )
  dim First_file = Find_file.GetFirst("*")


  if First_file != "" then

   dim findstring = searchtext.getValue()
   dim buffer
   dim buffer2
   dim datum

   if right(First_file , 5) = "notes" then
     'print First_file
     folders[foldercounter] = First_file
   end if

  dim Next_file

  While Next_file <> ""

    Next_file = Find_file.GetNext()

    if right(Next_file , 5) = "notes" then
      foldercounter += 1
      'print Next_file
      folders[foldercounter] = Next_file
    end if

  end while


  //--- now scan files in each folder ---

   for each folder in folders 

     'print folder
     Find_file = new wxDir()

     Find_file.Open( Pathname & "/" & folder )
     First_file = Find_file.GetFirst("*")


     if First_file != "" then

       if mid(First_file , 5,1) = "_" then
         'print " - " & First_file
         freeNum = freeFile()
         open Pathname & "/" & folder & "/" & First_file For Input As #freeNum
          while !eof(freeNum)
            Line Input #freeNum, buffer
            buffer2 = buffer
            if gk_search = 1 then
              buffer2 = lcase(buffer)
              findstring = lcase(findstring)
            end if
            if instr(buffer2 , findstring) >0 then
               'print " --- " & buffer
               datum = replace(left(First_file , 10), "_" , ".")
               slistbox1.append(datum & "  " & buffer)
            end if
          wend
         close #freeNum
       end if
       Next_file = "-"
       While Next_file <> ""

         Next_file = Find_file.GetNext()

         if mid(Next_file , 5 ,1) = "_" then

           'print " - " & Next_file
           freeNum = freeFile()
           open Pathname & "/" & folder & "/" & Next_file For Input As #freeNum
            while !eof(freeNum)
              Line Input #freeNum, buffer
              buffer2 = buffer
              if gk_search = 1 then
                buffer2 = lcase(buffer)
                findstring = lcase(findstring)
              end if
              if instr(buffer2 , findstring) >0 then
                 'print " --- " & buffer
                  datum = replace(left(Next_file , 10), "_" , ".")
                  slistbox1.append(datum & "  " & buffer)

              end if
            wend

           close #freeNum
         end if

      end while

      end if
    next

  else

   wxMessagebox("no notes were found...")

  end if
end sub

sub searchlist_clicked( event )

  Note_Changed(event)
  Monthly_Notes.Clear()
  alarmbox.clear()
  the_year = val(left(slistbox1.getStringSelection(),4))
  the_month = val(mid(slistbox1.getStringSelection(),6,2))
  the_day = val(mid(slistbox1.getStringSelection(),9,2))
  dim the_oldday = the_day
  'print the_year & the_month & the_day

  'print len(theyear) & " " & len(str(Year_Choice.getValue()))

  if Year_Choice.getValue() != the_year then
    Year_Choice.SetValue(the_year)
    change_year(dummy)
  end if

  'print val(themonth) & " " & Month_Choice.getSelection()

  if Month_Choice.getSelection() != the_month-1 then
    Month_Choice.SetSelection(the_month-1)
    change_month(dummy)
  end if


'get button id and check for valid date

    for i = 1 to 42
        button[i].SetFont(wxFont(wxDEFAULT,wxDEFAULT,wxNORMAL,wxLIGHT))
        button[i].SetForegroundColour(button_foreground_colour)

    end for
'highlight date clicked
dim offset = 1
while button[offset].getLabel() = " "
  offset += 1
wend
offset -= 1
the_day = the_oldday
dim button_id = the_day + offset
button[button_id].SetFont(wxFont(wxDEFAULT,wxDEFAULT,wxNORMAL,wxBOLD,1))
button[button_id].SetForegroundColour(button_clicked_foreground_colour)

Data = button_label[button_id] & "." & the_month & "." & the_year
'the_day = button_label[button_id]

if the_month < 10 then
    dim the_month1 = "0" & str(the_month)
else
    the_month1 = the_month
end if
if the_day < 10 then
    dim the_day1 = "0" & str(the_day)
else
    the_day1 = the_day
end if
dim File_Data = the_year & "_" & the_month1 & "_" & the_day1
GLOBAL_THEYEAR = the_year
//**MarkNEW3
GLOBAL_current_date = File_Data & ".mcn"



if fileexists (configdir & "/" & GLOBAL_THEYEAR & "notes/" & File_Data & ".mcn") then
    Monthly_Notes.LoadFile(configdir & "/" & GLOBAL_THEYEAR & "notes/" & File_Data & ".mcn")
end if

  Select_Notes_List(File_Data)

//**MarkNEW

Notes_Label.SetLabel(Data)


plugins_make_note(File_Data)
Monthly_Notes.refresh()



end sub




